/*******************************************************************************
 *
 * Holt einen String vom Generator ab. Liefert True, wenn etwas empfangen wurde
 * Art = TRUE benutzt Timeout
 *
 *******************************************************************************/
char GeneratorGetString (char Art)
 {
  char Puffer;
  char i = 0;
  long TimeoutTicker;

  memset (outpbuf,0,Buflen);	                    					// Buffer lschen
  TimeoutTicker = Get_Ticker ();                            // Wie spt isses ?

  while ( (  strstr (outpbuf, "\r\n") == NULL ) && ( (TimeoutTicker + GeneratorAckDelay) > Get_Ticker () ) )
   {
     Puffer = get_char_usart (Generator);            				// Sind Zeichen da ?
     if (Puffer != '\0')
      { // Wenn ja, aufsammeln
       outpbuf [i] = Puffer;
       if (i < Buflen) i++;
      } else
       if (!Art) { outpbuf [0] = '\r'; outpbuf [1] = '\n'; }

   } // Von while (!Fertig)

  return ((  strstr (outpbuf, "\r\n") != NULL );            // Ergebniss zurckliefern

 }

/**************************************************************************
 *
 * Schaltet den Generator Ein/Aus. Liefert OK bei korrekter Kommunikation
 *
 **************************************************************************/
char GeneratorSet (char Leistung, char OnOff)
 {
  char Kommando [6];

  // Generieren der Zeichenkette
  strcpy (Kommando, "P1");
  if (Leistung < 100) strcat (Kommando, "0");
  inttostr (Leistung);
  strcat (Kommando, outpbuf);
  strcat (Kommando, "\r");

  // Senden der Ein-bzw. Aussschaltsequenz
  if (OnOff)
   {
    put_string_usart (Generator, Kommando);								// Reiss an das Ding
    System.GeneratorLaeuft = TRUE;
   } else
   {
    put_string_usart (Generator, GeneratorAus);           // Mog dat Ding ut !
    System.GeneratorLaeuft = FALSE;
   }

  // Jetzt sollte eigentlich ein Ack gekommen sein
  if (!GeneratorGetString (TRUE)) return (FALSE);

  // Stimmte das auch ?
  return (strstr (outpbuf,GeneratorAck) != NULL);

 }

/************************************************************
 *
 * Schickt einen String zum Generator und wartet eine
 * Antwort ab
 * Liefert FALSE, falls keine kam
 *
 ************************************************************/
char GeneratorKom (const char *data)
 {
  #define AnzahlVersuche    3

  char Empfangsflag = FALSE;
  char Versuche = 0;

  while ( (!Empfangsflag) && (Versuche < AnzahlVersuche) )
   {

    outpbuf [0] = '\0';

     // Textstring senden
    put_string_usart (Generator, data);
    Empfangsflag = GeneratorGetString (TRUE);
    Versuche++;

   } // Von While...

   // Ergebniss zurckliefern
   return (Empfangsflag);
 }

/************************************************************
 *
 * Liest die Khlwassertemperatur [C] aus dem Generator aus
 *
 ************************************************************/
int GeneratorGetTemp (void)
 {
  long Delayticker;                                   // Timeout-berwachung
  char Empfangsflag  = FALSE;                         // Flag fr erfolgreichen Empfang
  char Versuche = 0;                                  // Anzahl der kommunikationsversuche
  char Zeichen;                                       // Empfangenes Zeichen
  char i;                                             // Zhlvariable
  char *Zeiger;                                       // zeiger auf den String

  while ( (Versuche < 8) && (!Empfangsflag) )
   {
    // Werteausgabe anwerfen
    put_string_usart (Generator, GeneratorWerteEin);

    // Warten, bis ein Text zurckgekommen ist
    Delayticker = Get_Ticker ();

    // Zeile reinholen
    memset (outpbuf, 0, Buflen);
    i = 0;
    Zeichen = 0;
    while ( (Zeichen != '\n') && ((Delayticker + GeneratorSendDelay) > Get_Ticker ()) )
     {
      Zeichen = get_char_usart (Generator);
      if (Zeichen != 0)
        {
         outpbuf [i] = Zeichen;
         if (i < (Buflen-1)) i++;

         // Stringlnge berwachen ! Der erste Datensatz ist ohne Belang. Deshalb beschneiden um
         // 'Buflen' nicht zu berschreiten
         if ( (strstr (outpbuf, "Sek: ")) && (i > 8) )
          {
           memset (outpbuf, 0, Buflen);
           i = 0;
          }

        } // Von if (Zeichen != 0)

     } // Von while (Zeichen != '\n')

    if ( (strstr (outpbuf, "I: ") == NULL) || (strstr (outpbuf, "T: ") == NULL) )
     {
       Versuche++;                                          // Anzahl rauf
     } else Empfangsflag = TRUE;

   }

  outpbuf [Buflen-1] = '\0';

  // Zurckgelieferten String auseinandernehmen "Sek:xx T:xx I:xx F:xx.x"
  Zeiger = strstr (outpbuf, "T:");                      // Richtige Stelle heraussuchen
  Zeiger += 6;                                          // Hinter das Ende setzen
  *Zeiger = '\0';                                       // Stringende definieren

  // Werteausgabe wieder abschalten
  put_string_usart (Generator, GeneratorWerteAus);

  // Empfangpuffer leeren nach einer kurzen Pause
  Delayms (200);
  flush_usart (Generator);

  // Ergebniss zurckliefern
  if (Versuche == 8) return (0); else return (atoi (strstr (outpbuf, "T:")+4));
 }

/************************************************************
 *
 * Liest die Softwareversion aus dem Generator aus
 *
 ************************************************************/
void GeneratorSoftver (void)
 {
  long Delayticker;                                   // Timeout-berwachung
  char Empfangsflag  = FALSE;                         // Flag fr erfolgreichen Empfang
  char Versuche = 0;                                  // Anzahl der kommunikationsversuche
  char Zeichen;                                       // Empfangenes Zeichen
  char i;                                             // Zhlvariable

  while ( (Versuche < 8) && (!Empfangsflag) )
   {
    // Werteausgabe anwerfen
    put_string_usart (Generator, GeneratorSoftVer);

    // Warten, bis ein Text zurckgekommen ist
    Delayticker = Get_Ticker ();

    // Zeile reinholen
    memset (outpbuf, 0, Buflen);
    i = 0;
    Zeichen = 0;
    while ( (Zeichen != '\n') && ((Delayticker + GeneratorSendDelay) > Get_Ticker ()) )
     {
      Zeichen = get_char_usart (Generator);
      if (Zeichen != 0)
        {
         outpbuf [i] = Zeichen;
         if (i < (Buflen-1)) i++;

        } // Von if (Zeichen != 0)

     } // Von while (Zeichen != '\n')

    if (strstr (outpbuf, "ion") == NULL)
     {
       Versuche++;                                    // Anzahl rauf
     } else Empfangsflag = TRUE;

   // Debugausgabe
   /*
   put_char_usart (Drucker, Versuche+48);
   put_string_usart (Drucker, " ");
   put_string_usart (Drucker, outpbuf);
   put_string_usart (Drucker, "\n\r");
   */
   }

  outpbuf [Buflen-1] = '\0';

  // Empfangpuffer leeren nach einer kurzen Pause
  Delayms (200);
  flush_usart (Generator);

  // Ergebniss zurckliefern
  if (Versuche == 8) memset (outpbuf, 0, Buflen);
 }


/***************************************************************
 *
 * Liefert die Schmelzzeit aus dem Generator in Minuten
 *
 ***************************************************************/
int GeneratorTime (void)
 {
  char i  = 0;                                      // Zhlvariable
  int Minuten = 0;
  char Zeilenzaehler = 0;                           // Zhler fr empfangene Zeichen
  char Zeichen;                                     // Empfangenes Zeichen
  char pos;                                         // Stringpositionen

  // put_string_usart (Drucker, "Hier");
  Delayms (10);                                     // Kurze Pause

  // Werteausgabe anwerfen
  if (!GeneratorKom (GeneratorStatus)) return (0);

  // Timer abschalten
  TMR1IE = 0;

  //--------------------------------------------------------------------------------
  // Jetzt folgen vom Generator verschiedene Informationen in mehreren Textzeilen :
  //
  // 0 Temp-Abschaltung
  // 0 Zeit-Abschaltung
  // 0 berstrom-Abschaltung
  // 3 Unterstrom-Abschaltung
  //
  //  0 Tag(e)
  //  0 Stunde(n)
  //  15 Minuten
  //  55 Sekunden
  //  SN: C0535
  //
  // Das heisst, die fraglichen Informationen befinden sich in den Zeilen 6-8
  // (beginnend mit Zeile 1) und mssen aus dem Datenstrom ausgefiltert werden
  // (in Echtzeit, da die Pufferrung nicht ausreicht)
  //
  //--------------------------------------------------------------------------------

  //-----------------------------------------------------------------------------------------
  // Textzeilen der Reihe nach zusammensetzen und berprfen (9 Zeilen sollten rberkommen)
  //-----------------------------------------------------------------------------------------
  Zeilenzaehler = 0;
  while (Zeilenzaehler < 9)
   {
    // Startklar fr die nchste Zeile
    i = 0;
    memset (outpbuf, 0, Buflen);
    Zeichen = 0;

    // Zeile reinholen
    // Timeout = 0;
    while ( (Zeichen != '\n') /* && (Timeout < TimeoutWert) */)
     {
      Zeichen = get_char_usart (Generator);
      if (Zeichen != 0)
        {
         outpbuf [i] = Zeichen;
         // Timeout = 0;
         if (i < (Buflen-1)) i++;
        }
      // Timeout++;
     } // Von while (Zeichen != '\r')

    // Abbruch bei Timeout
    // if (Timeout >= TimeoutWert) Zeilenzaehler = 9;

    //-----------------------------------------------------
    // Eine Zeile ist drin, berprfen auf gltigen Inhalt
    //-----------------------------------------------------
    if ((strstr (outpbuf, "Tag") != NULL))
     {
      pos = strlen (outpbuf);                                   // Ende ermitteln
      while ( (outpbuf [pos] != ' ') && (pos > 0) ) pos--;      // Leerzeichen finden
      outpbuf [pos] = '\0';                                     // Stringende setzen
      if (outpbuf [1] < 0x20) outpbuf [1] = ' ';
      if (outpbuf [1] < 0x20) outpbuf [1] = ' ';
      Minuten = atoi (outpbuf) * 60 * 24;                       // Zahlenwert errechnen
     }

    if ((strstr (outpbuf, "Stunde") != NULL))
     {
      pos = strlen (outpbuf);                                   // Ende ermitteln
      while ( (outpbuf [pos] != ' ') && (pos > 0) ) pos--;      // Leerzeichen finden
      outpbuf [pos] = '\0';                                     // Stringende setzen
      if (outpbuf [1] < 0x20) outpbuf [1] = ' ';
      if (outpbuf [1] < 0x20) outpbuf [1] = ' ';
      Minuten += atoi (outpbuf) * 60;                           // Zahlenwert errechnen
     }

    if ((strstr (outpbuf, "Minute") != NULL))
     {
      pos = strlen (outpbuf);                                   // Ende ermitteln
      while ( (outpbuf [pos] != ' ') && (pos > 0) ) pos--;      // Leerzeichen finden
      outpbuf [pos] = '\0';                                     // Stringende setzen
      if (outpbuf [1] < 0x20) outpbuf [1] = ' ';
      if (outpbuf [1] < 0x20) outpbuf [1] = ' ';
      Minuten += atoi (outpbuf);                                // Zahlenwert errechnen
     }

    //-------------------
    // Nchste Zeile....
    //-------------------
    Zeilenzaehler++;

   } // Von while (Zeilenzaehler < 10)

  // Timer einschalten
  TMR1IE = 1;

   return (Minuten);

 }

/**************************************************
 *
 * Liefert die Seriennummer des Generators zurck
 *
 **************************************************/
void GeneratorSerial (void)
 {

  char i  = 0;                                      // Zhlvariable
  char Zeilenzaehler = 0;                           // Zhler fr empfangene Zeichen
  char Puffer [7];                                  // Zwischenspeicher
  char Zeichen;                                     // Empfangenes Zeichen

  memset (outpbuf, 0, Buflen);
  memset (Puffer,0,6);
  strcat (Puffer, "X0000");

  // Werteausgabe anwerfen
  if (!GeneratorKom (GeneratorStatus)) return;

  // Timer abschalten
  TMR1IE = 0;

  //--------------------------------------------------------------------------------
  // Jetzt folgen vom Generator verschiedene Informationen in mehreren Textzeilen :
  //
  // 0 Temp-Abschaltung
  // 0 Zeit-Abschaltung
  // 0 berstrom-Abschaltung
  // 3 Unterstrom-Abschaltung
  //
  //  0 Tag(e)
  //  0 Stunde(n)
  //  15 Minuten
  //  55 Sekunden
  //  SN: C0535
  //
  // Das heisst, die fraglichen Informationen befinden sich in den Zeilen 6-8
  // (beginnend mit Zeile 1) und mssen aus dem Datenstrom ausgefiltert werden
  // (in Echtzeit, da die Pufferrung nicht ausreicht)
  //
  //--------------------------------------------------------------------------------

  //-----------------------------------------------------------------------------------------
  // Textzeilen der Reihe nach zusammensetzen und berprfen (9 Zeilen sollten rberkommen)
  //-----------------------------------------------------------------------------------------
  Zeilenzaehler = 0;
  while (Zeilenzaehler < 9)
   {
    // Startklar fr die nchste Zeile
    i = 0;
    memset (outpbuf, 0, Buflen);
    Zeichen = 0;

    // Zeile reinholen
    while (Zeichen != '\n')
     {
      Zeichen = get_char_usart (Generator);
      if (Zeichen != 0)
        {
         outpbuf [i] = Zeichen;
         if (i < (Buflen-1)) i++;
        }

     } // Von while (Zeichen != '\r')

    //-----------------------------------------------------
    // Eine Zeile ist drin, berprfen auf gltigen Inhalt
    //-----------------------------------------------------
   if (strstr (outpbuf, "SN:") != NULL)
    memcpy (Puffer, strstr (outpbuf, "SN:")+4, 5);        // Seriennummer ausschneiden

    //-------------------
    // Nchste Zeile....
    //-------------------
    Zeilenzaehler++;

   } // Von while (Zeilenzaehler < 10)

  // Puffer wieder umkopieren
  memcpy (outpbuf, Puffer, 6);

  // Timer einschalten
  TMR1IE = 1;

 }
